AppTitle "StrucherMaker"


Print "StrucherMaker0.63 by Lobby"
Print
Print "-+Zusatzparameter(d=Standart)"
Print "  |"
z1=Int(Input$("  +Anzahl der Halme?(d=500): "))
Print "    |"
z2#=Float#(Input$("    +Radius der halme?(d=0.5): "))
Print "    |"
z3=Int(Input$("    +Anzahl der Segmente?(d=6): "))
Print "    |"
z4#=Float#(Input$("    +Transparenz?(d=0.2): "))
Print "      |"
rcs$=Input$("      +Farbe Rot?(d=0): ")
Print "      |"
gcs$=Input$("      +Farbe Grn?(d=1): ")
Print "      |"
bcs$=Input$("      +Farbe Blau?(d=0): ")
Print "      |"
shs$=Input$("      +Glanzeffekt?(d=0): ")

If z1=0 Then z1=500
If z2=0 Then z2#=0.5
If z3=0 Then z3=6
If z4=0 Then z4#=0.2
If Asc(rcs)<0 Then rc=0 Else rc=rcs
If Asc(gcs)<0 Then gc=1 Else gc=gcs
If Asc(bcs)<0 Then bc=0 Else bc=bcs
If Asc(shs)<0 Then sh#=0 Else sh#=Float#(shs)


Graphics3D 800,600,32,2

SeedRnd MilliSecs()
grass_tex=CreateTexture(64,64)
SetBuffer TextureBuffer(grass_tex)
ClsColor 60,50,0
Cls
Color 50,200,50
For z=0 To 100
	Plot Rand(65)-1,Rand(65)-1
Next
ClsColor 0,0,0
Color 255,255,255
Flip

SetBuffer BackBuffer()

ScaleTexture grass_tex,40,40

pcam=CreatePivot()
cam=CreateCamera(pcam)
CameraClsColor cam,160,200,255
MoveEntity cam,0,0,-50
MoveEntity pcam,0,20,0
TurnEntity pcam,20,0,0

cb=CreateBusch(z1,z2,z3,z4,rc,gc,bc,sh#)
ScaleEntity cb,0.8,0.8,0.8

p=CreatePlane()
EntityTexture p,grass_tex
EntityAlpha p,0.9
m=CreateMirror()

l=CreateLight()
MoveEntity l,0,30,-60

EntityType cam,1
EntityType p,2
Collisions 1,2,3,3

timer=CreateTimer(24)
While Not KeyHit(1)
	If KeyDown(200) Then TurnEntity pcam,1,0,0
	If KeyDown(208) Then TurnEntity pcam,-1,0,0
	If KeyDown(203) Then TurnEntity pcam,0,-1,0,1
	If KeyDown(205) Then TurnEntity pcam,0,1,0,1
	If KeyDown(30) Then MoveEntity cam,0,0,1
	If KeyDown(44) Then MoveEntity cam,0,0,-1
	
	If KeyHit(17) Then
		wf=wf=0
		WireFrame wf
	EndIf
	;TurnEntity cb,0,2,0
	UpdateWorld
	RenderWorld
	
	fps#=(19*fps#+(1000./(MilliSecs()-FPS_LAST)))/20.:FPS_LAST=MilliSecs()
	Text 0,0,(fps#)+" FPS"
	Text 0,11,TrisRendered()+" Triangles"
	Text 0,30,z1+" Halme"
	Text 0,41,z2+" Radius"
	Text 0,52,z3+" Segmente"
	Text 0,63,z4+" Transparenz"
	
	Flip
	If WaitTimer(timer)>1 Then
		If m Then
			FreeEntity m
			m=0
		EndIf
	EndIf
Wend


Function CreateBusch(mz=100,r#=0.5,seg=8,trans#=1,rc=0,gc=1,bc=0,sh#=0)
	mesh=CreatePivot()
	For z=0 To mz
		w=Rand(360)
		g=Rand(25)
		x#=Cos#(w)*g
		y#=Sin#(w)*g
		l3d=Line3D(x#/10,0,y#/10,x#,Rand(30)+20-(BVFloat#(x#,-x#)/4+BVFloat#(y#,-y#)/4),y#,r#,seg,Rand(20+180*rc)+10+45*rc,Rand(20+180*gc)+10+45*gc,Rand(20+180*bc)+10+45*bc)
		EntityAlpha l3d,trans#
		EntityParent l3d,mesh
		EntityShininess l3d,sh#
	Next
	Return mesh
End Function

Function Line3D(x1#,y1#,z1#,x2#,y2#,z2#,r#=1,segments=32,red=255,green=255,blue=255,texture=0)
	cc=CreateCylinder(segments)
	PositionEntity cc,x1,y1,z1
	p=CreatePivot()
	PositionEntity p,x2,y2,z2
	PointEntity cc,p
	TurnEntity cc,90,0,0
	MoveEntity cc,0,Seglen3D#(x1,y1,z1,x2,y2,z2)/2,0
	ScaleEntity cc,r#,Seglen3D#(x1,y1,z1,x2,y2,z2)/2,r#
	EntityColor cc,red,green,blue
	If texture Then EntityTexture cc,texture
	Return cc
End Function

Function Seglen3D#(x1#,y1#,z1#,x2#,y2#,z2#)
	Return Sqr((x1#-x2#)*(x1#-x2#)+(y1#-y2#)*(y1#-y2#)+(z1#-z2#)*(z1#-z2#))
End Function

Function BVFloat#(v1#,v2#)
	If v1#>v2# Then rn#=v1#
	If v2#>v1# Then rn#=v2#
	Return rn#
End Function